import { defineComponent, ref, watchEffect, onMounted, resolveComponent, openBlock, createElementBlock, Fragment, createVNode, h } from "vue";
const _sfc_main = /* @__PURE__ */ defineComponent({
  props: {
    val: { default: "" },
    numbers: { default: () => ["0", "1", "2", "3", "4", "5", "6", "7", "8", "9"] },
    capitalCaseLetters: { default: () => [
      "A",
      "B",
      "C",
      "D",
      "E",
      "F",
      "G",
      "H",
      "I",
      "J",
      "K",
      "L",
      "M",
      "N",
      "O",
      "P",
      "Q",
      "R",
      "S",
      "T",
      "U",
      "V",
      "W",
      "X",
      "Y",
      "Z"
    ] },
    lowerCaseLetters: { default: () => [
      "a",
      "b",
      "c",
      "d",
      "e",
      "f",
      "g",
      "h",
      "i",
      "j",
      "k",
      "l",
      "m",
      "n",
      "o",
      "p",
      "q",
      "r",
      "s",
      "t",
      "u",
      "v",
      "w",
      "x",
      "y",
      "z"
    ] },
    showNumbers: { type: Boolean, default: true },
    showCapitalCaseLetters: { type: Boolean, default: true },
    showLowerCaseLetters: { type: Boolean, default: true }
  },
  emits: ["isValid", "getCode"],
  setup(__props, { emit }) {
    const props = __props;
    const alpha = ref([
      ...props.showNumbers ? props.numbers : [],
      ...props.showCapitalCaseLetters ? props.capitalCaseLetters : [],
      ...props.showLowerCaseLetters ? props.lowerCaseLetters : []
    ]);
    let code = ref("");
    const captcha = () => {
      let i;
      for (i = 0; i < 6; i++) {
        code.value += alpha.value[Math.floor(Math.random() * alpha.value.length)];
      }
    };
    watchEffect(() => {
      if (code.value === props.val) {
        emit("isValid", true);
      } else {
        emit("isValid", false);
      }
    });
    onMounted(() => {
      captcha();
      emit("getCode", code.value);
    });
    const render = () => {
      return h("div", [
        h("span", { style: "background:#eee;padding:15px" }, code.value),
        h("button", {
          onClick: () => {
            code.value = "", captcha();
          }
        }, `change`)
      ]);
    };
    return (_ctx, _cache) => {
      const _component_jsxNode = resolveComponent("jsxNode");
      return openBlock(), createElementBlock(Fragment, null, [
        createVNode(_component_jsxNode),
        createVNode(render)
      ], 64);
    };
  }
});
export { _sfc_main as default };
